bash script - sftpbatchfile - stop on failure


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting bash script - sftpbatchfile - stop on failure
# 29  
Old 04-05-2012
Quote:
Originally Posted by Corona688
What is the purpose of the pipe there? echo reads nothing from standard input.

Did you perhaps mean || ? remove the file and, on failure, print the error code?

The purpose would be to execute the rm and write the exit code of the rm to a file on the local machine. (sorry fairly new to scripting)

so you mean like this then?

Code:
 echo "!rm -f "$FILE" || echo $? >> "$SFTPCHECK_PUT_RM >> $commandlist


Last edited by Kerberos; 04-05-2012 at 12:25 PM..
# 30  
Old 04-05-2012
Ah, I see.

Your quotes had me confused, because quotes don't work that way. You weren't getting the string you expected in the file.

And the variables substituted immediately, not when the line was actually ran.

And | still doesn't make sense there.

How about:
Code:
echo '!'"rm bs2.html  -f \"$FILE\" || echo \$? >> \"$SFTPCHECK_PUT_RM\"" >> $commandlist

This User Gave Thanks to Corona688 For This Post:
# 31  
Old 04-06-2012
Quote:
Originally Posted by rbatte1
I know that there is a no SSH to drive it himself, however the other end is moving the files off as they arrive, so perhaps that can be altered to expect a compressed tar file, was my thought.

It depends what the receiving company is prepared to do after they "fixed" a working system that allowed Kerberos to send single files and therefore delete single files in a controlled way. Unfortunately now you want to open a single connection and move all of the files.


Another alternate would be to fire in something like into the sftp batch file:-
Code:
put localfile1 remotefile1
!rm localfile1 || kill `ps -f|grep sft[p]|cut -f3 -d " "`
put localfile2 remotefile2
!rm localfile2 || kill `ps -f|grep sft[p]|cut -f3 -d " "`
put localfile3 remotefile3
!rm localfile3 || kill `ps -f|grep sft[p]|cut -f3 -d " "`

This will cause sftp to get a kill -15 and exit with $?=1 You can then pick that up with your shell script.


Does that help?



Robin
Liverpool/Blackburn
UK
This works great, but i cant implement it from my boss however Smilie Smilie
he thinks it is too risky just killing a process like that every time it fails :s (read as, he thinks a local remove of file which you are owner of will fail a lot, sigh)

---------- Post updated at 09:37 AM ---------- Previous update was at 09:35 AM ----------

Quote:
Originally Posted by Corona688
Ah, I see.

Your quotes had me confused, because quotes don't work that way. You weren't getting the string you expected in the file.

And the variables substituted immediately, not when the line was actually ran.

And | still doesn't make sense there.

How about:
Code:
echo '!'"rm bs2.html  -f \"$FILE\" || echo \$? >> \"$SFTPCHECK_PUT_RM\"" >> $commandlist


just tested and it seems to work Smilie
so if i get this right, you escape the quotes and the $ sign. Why didnt I think of that Smilie
will post the whole scripts when i tested completely.
fingers crossed now :-)


*** edit ***
just 1 more question which i cant seem to find the answer to.
What is exactly the difference between | and || ?
# 32  
Old 04-06-2012
Quote:
Originally Posted by Kerberos
just 1 more question which i cant seem to find the answer to.
What is exactly the difference between | and || ?
|| is a control operator that specifies what to do if the test is false.
|| actually represent the (logical) OR operator
[ -x file ] || echo "file is NOT executable"
if the file is NOT executable then (( [ -x file ] )) command returns a non-zero exit status code.
and if this status code is non-zero value then (( echo "file is executable" )) command is executed by shell.
for example
Code:
# touch file
# ls -ltr file
-rwxr--r-- 1 root root 52 2012-04-06 21:23 file
# chmod -x file  ## remove the executable permission
# [ -x file ] || echo "file is NOT executable"
file is NOT executable


| is a control operator that create a pipeline structure.
rpm -qa|grep glibc
in this (( grep )) reads the previous command's ((rpm -qa)) output via a pipe (|) as input for itself ((grep glibc)) and process on it.
for example
Code:
# rpm -qa
..........
........
gtkspell-devel-2.0.11-2.1
gtk+-devel-1.2.10-56.el5
beecrypt-4.1.2-10.1.1
elfutils-devel-static-0.137-3.el5
..................

/* you can think like this */
Code:
# grep glibc "..........
........
gtkspell-devel-2.0.11-2.1
gtk+-devel-1.2.10-56.el5
beecrypt-4.1.2-10.1.1
elfutils-devel-static-0.137-3.el5
.................."

grep searches the glibc in the ((rpm -qa)) output and write the results..

regards
ygemici
# 33  
Old 04-06-2012
ok guys,
thanks a lot for the help. The 2nd part of my scriptseries is finished. (couldnt have done it without the help)

here is the final result ;-)

Code:
#!/bin/bash
## created by: Tommy Dekoster
## on: 15/03/2012
## Purpose: This script will be used om SFTP server via autosys to put files from acces & transit (.edi files)on the VAN server
## exit codes
## exit 6: the sftp connection to VAN server failed
echo "Definition of different exit codes"
echo "=================================="
echo "exit 6 = sftp connection to the VAN server failed"
echo

## variables
## vanuser: username used to connect to the VAN server from the SFTP server
## vanserver: Ip adress or hostname of the VAN server
## tbtsftp: to be treated folder on SFTP (files to be sent from sftp to VAN)
## remotepath_VAN: Directory on the VAN server where files need to be put
## commandlist: List of commands that will be executed over SFTP connection between SFTP1 and VAN server
## SFTPCHECK_PUT_RM: file where the last executed command from the commandlist will be
vanuser=$1
vanserver=$2
tbtsftp=$3
remotepath_VAN=$4
commandlist=$5
SFTPCHECK_PUT_RM=$6
filetype=$7
echo "Definition of different variables"
echo "================================="
echo "vanuser: username used to connect to the VAN server from the SFTP server"
echo "vanserver: Ip adress or hostname of the VAN server"
echo "tbtsftp: to be treated folder on SFTP (files to be sent from sftp to VAN)"
echo "remotepath_VAN: Directory on the VAN server where files need to be put"
echo "commandlist: List of commands that will be executed over SFTP connection between SFTP1 and VAN server"
echo "SFTPCHECK_PUT_RM: file where the last executed command from the commandlist will be"
echo "filetype: the type of files wich need to be moved/sftp'd"
echo
echo "Values of variables"
echo "==================="
echo "vanuser: "$vanuser
echo "vanserver: "$vanserver
echo "tbtsftp: "$tbtpath
echo "remotepath_VAN: "$remotepath_VAN
echo "commandlist: "$commandlist
echo "SFTPCHECK_PUT_RM: "$SFTPCHECK_PUT_RM
echo "filetype: "$filetype
echo
echo

## The actual procedure starts here
## Invalid files will be moved to a directory
## The old commandlist and sftp_put_rm checklist will be cleaned
## A commandlist containing put, rm, check on rm error will be created
## The generated commandlist will be executed over sftp
echo "Start of actual procedure"
echo "========================="
echo "Searching files other then ."$filetype" in "$tbtsftp" and move them to /tmp/invalid_filetype"
mkdir -p /tmp/invalid_filetype
find $tbtsftp -type f -not -name "*."$filetype -exec mv {} /tmp/invalid_filetype/ \;
echo
echo
echo "Deleting old commandlist if exists"
echo > $commandlist
echo
echo "Deleting old checkfile"
echo > $SFTPCHECK_PUT_RM
echo
echo "Creating commandlist"
echo
for FILE in `ls -tr $tbtsftp`
        do
                echo "put "$FILE
                echo "cd "$remotepath_VAN >> $commandlist
                echo "put "$FILE >> $commandlist
                echo "!rm -f "$FILE
                echo '!'"rm -f \"$FILE\" || \$? >> \"$SFTPCHECK_PUT_RM\"" >> $commandlist
        done
echo
echo "Executing commandlist over sftp"
echo
sftpconnect=$vanuser@$vanserver
cd $tbtsftp
sftp -b $commandlist $sftpconnect 2>&1
## Build in retry if initial connection doesnt work
        if [ $? != '0' ]; then
                echo First sftp connection failed, trying again.
                sftp -b $commandlist $sftpconnect 2>&1
                if [ $? != '0' ]; then
                        echo There is a problem connecting to the VAN server
                        echo Preforming ping
                        ping $vanserver -c 1
                        exit 6
                fi
        fi

Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

How to block first bash script until second bash script script launches web server/site?

I'm new to utilities like socat and netcat and I'm not clear if they will do what I need. I have a "compileDeployStartWebServer.sh" script and a "StartBrowser.sh" script that are started by emacs/elisp at the same time in two different processes. I'm using Cygwin bash on Windows 10. My... (3 Replies)
Discussion started by: siegfried
3 Replies

2. Shell Programming and Scripting

Bash variable assignment failure/unary operator expected

I have a little code block (executing on AIX 7.1) that I cannot understand why the NOTFREE=0 does not appear to be assigned even though it goes through that block. This causes a unary operator issue. #!/bin/bash PLATFORM="AIX" NEEDSPC=3000 set -x if ; then lsvg | grep -v rootvg | while... (6 Replies)
Discussion started by: port43
6 Replies

3. Debian

Bash script to STOP installation 'if' a file exists...

Hey all, Here's my dilemma: 1. I'm a newbie at scripting! 2. I need to create a script that checks: If a file size is equal to zero, then stop the installation. Is there a way to do this or am I wasting my time??? Thanx in advance! :b: (2 Replies)
Discussion started by: thazsar
2 Replies

4. UNIX for Dummies Questions & Answers

boot up failure unix sco after power failure

hi power went out. next day unix sco wont boot up error code 303. any help appreciated as we are clueless. (11 Replies)
Discussion started by: fredthayer
11 Replies

5. Shell Programming and Scripting

Stop child script by stoping parent script

Hi everyone, I have this problem with a script I'm writting. I want to execute a code running in the background several times through a script. I am writting it like that parent_script for a in 1 2 3 4 5 do exec test -n $a done What I want to do is when parent_script is killed,... (0 Replies)
Discussion started by: geovas
0 Replies

6. Shell Programming and Scripting

How to stop a script running in remote server from local script

Hi, I have googled for quite some time and couldn't able to get what exactly I am looking for.. My query is "how to stop a shell script which is running inside a remote server, using a script"??? can any one give some suggestions to sort this out. (1 Reply)
Discussion started by: mannepalli
1 Replies

7. UNIX for Dummies Questions & Answers

Anyone know?: How the 'for'-loop could stop working in interactive bash shell?!

It is happening with my sessions already second time: a 'for'-loop for some reason stop to work as expected. That means or it is looping without exitting, or it is not loop even once. Here example of my try when it is not processing even one loop. You can see, I start new subshell and... (14 Replies)
Discussion started by: alex_5161
14 Replies

8. Shell Programming and Scripting

script don't stop

Hello everybody! I am new to this and I am trying to change a script in an open source program that plots some offset vectors and then calls a postscript viewer. I have commented away the call for the postscript viewer but somehow the script doesn't return to the shell prompt. I cant figure out... (3 Replies)
Discussion started by: larne
3 Replies

9. UNIX for Dummies Questions & Answers

Stop a shell script

Hi, I am writing a bash shell script. How can I tell it to stop. For example, I would like to have something similar to the following: mike=1 if ; then STOP THE SCRIPT fi (3 Replies)
Discussion started by: msb65
3 Replies

10. Shell Programming and Scripting

Script does not stop when doing a read

Hi Folks, I have been trying to create a script wherein after it reads a certain number of data, it will pause and ask the user if he wants to continue or not. However, it seems that when it is supposed to read the user's answer, the script will go into a loop. What is wrong with my script here?... (7 Replies)
Discussion started by: rooseter
7 Replies
Login or Register to Ask a Question